-- Dmo : nettoyage des users (utilisateurs de bases de donnes)
-----------------------------------------------------------------------------------------------------------------------------------------
-- Quels sont les users qui ne servent pas ?
-----------------------------------------------------------------------------------------------------------------------------------------
-- Orphaned users : Utilisateurs (authentification par instance) sans login existant 
DECLARE @SQL NVARCHAR(MAX)
    = N'
USE [?]
SELECT ''?'',U.name,
CASE WHEN U.name = ''dbo'' THEN ''Invalid DB Owner'' ELSE ''Orphaned User'' END AS warning,
U.type_desc,U.authentication_type_desc,U.create_date,U.modify_date 
FROM sys.database_principals U
LEFT JOIN sys.server_principals L ON L.sid = U.sid
WHERE U.type IN (''S'',''U'',''G'')
AND U.authentication_type NOT IN (0,2)  -- Instance authentication
AND L.sid IS NULL;';
DECLARE @Results TABLE
(
    db_name sysname
  , user_name sysname
  , warning VARCHAR(20)
  , type_desc NVARCHAR(60)
  , authentication_type_desc NVARCHAR(60)
  , create_date DATETIME
  , modify_date DATETIME
);
INSERT @Results
EXEC sp_MSforeachdb @SQL;
SELECT *
     , CASE
           WHEN warning = 'Orphaned User' THEN
               'USE ' + QUOTENAME(db_name) + '; DROP USER ' + QUOTENAME(user_name) + '; '
           ELSE
               ''
       END AS dropcmd
FROM @Results
ORDER BY 3
       , 1
       , 2;

-- Mais  vrifier avant de supprimer mes users, qu'ils ne soient pas propritaires d'objets...

