-- Dmo : nettoyage des bases inutilises

-----------------------------------------------------------------------------------------------------------------------------------------
-- Quels sont les bases qui ne servent pas ? Dlicat  identifier !
-----------------------------------------------------------------------------------------------------------------------------------------
-- 1. Surveiller les dates de modification de fichiers (mdf/ndf) : uniquement si modification (et lors du checkpoint), et attention aux jobs de maintenance
-- 2. XEvents : capture des logouts (ou plus...) avec database_name, principal_name, app_name...
-- 3. Job priodique et table de log pour surveiller les sessions (peu fiable)
-- 4. Accs aux tables (dm_db_index_usage_stats) : effac  chaque redmarrage


-----------------------------------------------------------------------------------------------------------------------------------------
-- date de modification des fichiers
-----------------------------------------------------------------------------------------------------------------------------------------
EXEC xp_cmdshell 'dir "C:\MSSQLData\MSSQL16.MSSQLSERVER\MSSQL\Data\*.*df" | findstr /v /i "\.ldf$"'

-----------------------------------------------------------------------------------------------------------------------------------------
-- XEvents
-----------------------------------------------------------------------------------------------------------------------------------------
CREATE EVENT SESSION [CaptureLogouts] ON SERVER 
ADD EVENT sqlserver.logout(
    ACTION(sqlserver.client_app_name,sqlserver.client_hostname,sqlserver.database_name,sqlserver.session_server_principal_name)
    WHERE ([sqlserver].[not_equal_i_sql_unicode_string]([sqlserver].[database_name],N'master') AND [sqlserver].[not_equal_i_sql_unicode_string]([sqlserver].[database_name],N'model') AND [sqlserver].[database_name]<>N'msdb' AND [sqlserver].[database_name]<>N'tempdb'))
ADD TARGET package0.event_file(SET filename=N'CaptureLogouts')
WITH (MAX_MEMORY=4096 KB,EVENT_RETENTION_MODE=ALLOW_SINGLE_EVENT_LOSS,MAX_DISPATCH_LATENCY=30 SECONDS,MAX_EVENT_SIZE=0 KB,MEMORY_PARTITION_MODE=NONE,TRACK_CAUSALITY=OFF,STARTUP_STATE=OFF)
GO

;WITH XEvents AS
(
	SELECT object_name, CAST(event_data AS XML) AS event_data
	FROM sys.fn_xe_file_target_read_file ( 'CaptureLogouts*.xel', NULL, NULL, NULL ) 
	WHERE object_name = 'logout'
)
SELECT object_name, 
	--XEvent timestamp is UTC. Adjust for local server time.
	DATEADD(HOUR, DATEDIFF(HOUR, GETUTCDATE(), GETDATE()), event_data.value ('(/event/@timestamp)[1]', 'DATETIME')) AS [timestamp],
	--logout
	event_data.value ('(/event/action[@name=''client_app_name'']/value)[1]', 'NVARCHAR(MAX)') AS [client_app_name],
	event_data.value ('(/event/action[@name=''client_hostname'']/value)[1]', 'NVARCHAR(MAX)') AS [client_hostname],
	event_data.value ('(/event/action[@name=''database_name'']/value)[1]', 'NVARCHAR(MAX)') AS [database_name],
	event_data.value ('(/event/action[@name=''session_server_principal_name'']/value)[1]', 'NVARCHAR(MAX)') AS [session_server_principal_name]
FROM XEvents


;WITH XEvents AS
(
	SELECT object_name, CAST(event_data AS XML) AS event_data
	FROM sys.fn_xe_file_target_read_file ( 'CaptureLogouts*.xel', NULL, NULL, NULL ) 
	WHERE object_name = 'logout'
), ShreddedEvents AS
(
SELECT object_name, 
	--XEvent timestamp is UTC. Adjust for local server time.
	DATEADD(HOUR, DATEDIFF(HOUR, GETUTCDATE(), GETDATE()), event_data.value ('(/event/@timestamp)[1]', 'DATETIME')) AS [timestamp],
	--logout
	event_data.value ('(/event/action[@name=''client_app_name'']/value)[1]', 'NVARCHAR(MAX)') AS [client_app_name],
	event_data.value ('(/event/action[@name=''client_hostname'']/value)[1]', 'NVARCHAR(MAX)') AS [client_hostname],
	event_data.value ('(/event/action[@name=''database_name'']/value)[1]', 'NVARCHAR(MAX)') AS [database_name],
	event_data.value ('(/event/action[@name=''session_server_principal_name'']/value)[1]', 'NVARCHAR(MAX)') AS [session_server_principal_name]
FROM XEvents)
SELECT MAX(timestamp) AS lastlogout,database_name FROM ShreddedEvents GROUP BY database_name;
GO


-----------------------------------------------------------------------------------------------------------------------------------------
-- job priodique : peu fiable. frquence, accs depuis une autre base, etc...
-----------------------------------------------------------------------------------------------------------------------------------------
	--DROP TABLE IF EXISTS msdb..DBUsage
	--CREATE TABLE msdb..DBUsage
	--(
	--    database_name sysname
	--  , login_name sysname
	--  --host_name sysname, program_name sysname, 
	--  , last_seen DATETIME2(0)
	--);
	--ALTER TABLE msdb..DBUsage ADD PRIMARY KEY (login_name, database_name);
MERGE msdb..DBUsage U
USING
(
    SELECT DB_NAME(database_id) database_name
         , login_name --, host_name, program_name 
    FROM sys.dm_exec_sessions
    WHERE is_user_process = 1
          AND DB_NAME(database_id) NOT IN ( 'master', 'model', 'msdb', 'tempdb' )
    GROUP BY DB_NAME(database_id)
           , login_name --,host_name, program_name
) AS S
ON S.database_name = U.database_name
   AND S.login_name = U.login_name --AND S.host_name = U.host_name AND S.program_name = U.program_name
WHEN MATCHED THEN
    UPDATE SET last_seen = SYSDATETIME()
WHEN NOT MATCHED THEN
    INSERT
    (
        database_name
      , login_name --, host_name, program_name
      , last_seen
    )
    VALUES
    (   S.database_name, S.login_name --, S.host_name, S.program_name
      , SYSDATETIME());

-- Accs aux bases
SELECT db.name
     , MAX(u.last_seen) AS last_connection
FROM sys.databases db
    LEFT JOIN msdb..DBUsage u
        ON db.name = u.database_name
WHERE db.name NOT IN ( 'master', 'model', 'msdb', 'tempdb' )
-- AND  (u.database_name IS NULL OR u.last_seen < DATEADD(MONTH,-3,SYSDATETIME())) AND db.name NOT IN ('master','model','msdb','tempdb')
GROUP BY name;

-----------------------------------------------------------------------------------------------------------------------------------------
-- Via sys.dm_db_index_usage_stats : sauf redmarrage
-----------------------------------------------------------------------------------------------------------------------------------------
SELECT name AS dbname
     , last_read
     , last_write
FROM sys.databases d
    LEFT JOIN
    (
        SELECT DB_NAME(database_id) AS dbname
             , MAX(GREATEST(last_user_scan, last_user_seek, last_user_lookup)) AS last_read
             , MAX(last_user_update) AS last_write
        FROM sys.dm_db_index_usage_stats
        WHERE user_seeks <> 0
              OR user_scans <> 0
              OR user_lookups <> 0
              OR user_updates <> 0
        GROUP BY DB_NAME(database_id)
    ) u
        ON d.name = u.dbname
WHERE d.name NOT IN ( 'master', 'model', 'msdb', 'tempdb' );


